/***************************************************************************
 *
 * Copyright (c) 1995 Promise Technology, Inc.  All rights reserved.
 * No part of this document may be reproduced or transmitted in any form or
 * by any means, electronic or mechanical, for any purpose, without the
 * express written permission of Promise Technology, Inc.
 *
 *
 * cam_exp.h - function prototypes provided by CAM
 *
 *
 ***************************************************************************/
 
#ifndef CAM_EXP_H
#define CAM_EXP_H
 

/*****************************************************************************************
*************			Export Function		********************************************						
*****************************************************************************************/

/***  cam.c  ***/
extern void CAM_GetInfo(PCAM_INFO pCAMInfo);
extern U8 CAM_Init(PADAPTER_CONFIG_INFO pAdapter);
extern U8 CAM_ReInit(PADAPTER_CONFIG_INFO pAdapter);
extern U8 CAM_Close(PADAPTER_CONFIG_INFO pAdapter);
extern U32 CAM_GetExtraData(U8 Adapter_ID, U8 bID);
extern void CAM_SetExtraData(U8 Adapter_ID, U8 bID, U32 value);
extern void CAM_ATAGetPacketCount(U8 Adapter_ID,PATA_MODULE_PACKET_COUNT pCAM_Module);
extern void CAM_ATASetPacketCount(U8 Adapter_ID,PATA_MODULE_PACKET_COUNT pCAM_Module);
extern void CAM_GetTimeoutTime(U8 Adapter_ID,PMODULE_TIMEOUT pCAM_Timeout);
extern void CAM_SetTimeoutTime(U8 Adapter_ID,PMODULE_TIMEOUT pCAM_Timeout);
extern void CAM_ControlBMRLongBurst(U8 Adapter_ID, U8 Status);
extern U8 CAM_EnumEncryptionKey(U8 Adapter_ID);

/***  cam_ata.c  ***/
extern U8 CAM_InitATAChannel(U8 bChannelNumber, void (*notify)(U8 bCh, U8 status));
extern U8 CAM_ResetATAChannel(U8 bChannelNumber, void (*notify)(U8 bCh, U8 status));
extern U8 CAM_EnumATAChannel(PCHNL_CONFIG pChnlConfig);
extern U8 CAM_ConfigATAChannel(PCHNL_CONFIG pChnlConfig);
extern U8 CAM_EnumATADevice(PDEV_CONFIG pDevConfig);
extern U8 CAM_ConfigATADevice(PDEV_CONFIG pDevConfig);
extern U8 CAM_SubmitATA (PATA_TASK pATATask);
extern U8 CAM_HardResetSATAChannel(U8 bChannelNumber);


/***  cam_swap.c  ***/
extern U8 CAM_EnumEnclosure(U8 bCh, PENCLOSURE_TYPE pBox);
extern U8 CAM_Get_Enclosure_Status(U8 bChannelNumber, PENCLOSURE_STATUS pBoxStatus);
extern void CAM_CtrlLED(U8 bChannelNumber, PCAM_Ctrl_LED pCtrl_LED);
extern U8 CAM_Enclosure_PowerOn(U8 bChannelNumber);
extern U8 CAM_Enclosure_PowerOff(U8 bChannelNumber);
extern U8 Data2SerialBus(U8 Adapter_ID, U32 WriteData);

/***  cam_isr.c  ***/
extern U32 CAM_ISR(U32 IRQHandle);


/***  cam_fm.c  ***/
extern U8 CAM_Find_FlashMemory (U8 Adapter_ID, PU8 pModelName);
extern U8 CAM_Erase_FlashMemory(U8 Adapter_ID);
extern U8 CAM_Write_FlashMemory(U8 Adapter_ID, U32 Offset, U32 BufSize, PU8 pDatabuf);
extern U8 CAM_Read_FlashMemory(U8 Adapter_ID, U32 Offset, U32 BufSize, PU8 pDatabuf);


/***  PSS10398  ***/
extern U8 CAM_InitSATAEnclosure(U8 Adapter_ID);
extern void CAM_InitWithoutDiskSATAEnclosures(U8 bAdapterNumber,PCAM_Ctrl_LED pCtrl_LED);
extern void CAM_CloseSATAEnclosure(U8 Adapter_ID);
extern U8 CAM_Set_HDAccess_LED_All(U8 Adapter_ID, U8 LED_Type,PCAM_HDAccess_LED_All pHDAccess_LED_All);
extern U8 CAM_Set_HDAccess_LED(U8 bChannelNumber,U8 LED_Type,U8 Flash);



/*****************************************************************************************
*************			Internal Used Function		****************************************						
*****************************************************************************************/

/***  cam.c  ***/
void WriteIndexUchar(PTR_SIZE BaseAddress, U8 Index, U8 Data );
U8 ReadIndexUchar(PTR_SIZE BaseAddress, U8 Index );
extern U8 CAMAllocSEQID(U8 Adapter_ID);
extern void CAMFreeSEQID(U8 Adapter_ID, U8 SEQID);
extern PVOID CAMAllocATAPacket(U8 bChannelNumber);
extern void CAMFreeATAPacket(U8 bChannelNumber , PVOID PacketAddress);
extern PVOID CAMAllocATASG(U8 bChannelNumber);
extern void CAMFreeATASG(U8 bChannelNumber, PVOID PacketAddress);
extern void checkConvertSG(PCAMSG  source_sg,PCAMSG target_sg);
extern void Put2SeqIDQueue(U8 Adapter_ID,PVOID PacketAddress,U8 SeqID,U8 Set_ulNCA);
extern void CAM_ResetSerialBusMachine(U8 Adapter_ID);
extern PVOID CAMAllocCamPacket(U8 bChannelNumber);
extern void CAMFreeCamPacket(U8 bChannelNumber , PVOID PacketAddress);


/***  cam_ata.c  ***/
extern void ATASoftResetModule(U8 bChannelNumber);
extern void FPDMAclearInterruptFlag(U8 bChannelNumber);
extern void ATAErrorStatus(PATA_TASK pATATask);
extern void ATAPIErrorStatus(PATA_TASK pATATask);
extern void SubmitInternelSense(PATA_TASK pATATask,PCAM_PACKET CAM_ATAPacket);
extern void (*ATA_Timeout_Function[])(void);
extern void (*ATA_Check_Port_Multiplier_Function[])(void);
extern void (*ATA_Polling_Channel_Function[])(void);
extern void Return_Waiting_ATAPackets(U8 bChannelNumber,U16 return_status);
extern void Return_Execute_ATAPackets(U8 bChannelNumber,PCAM_PACKET CAM_ATAPacket,U16 return_status);
extern void Abort_All_Undone_ATAPackets(U8 bChannelNumber,PCAM_PACKET CAM_ATAPacket);
extern void stopATAModule(U8 bChannelNumber);
extern void Back_All_Undone_ATAPackets(U8 bChannelNumber,PCAM_PACKET CAM_ATAPacket);
extern U8 WaitForDrq(PTR_SIZE IDEBaseAddress);
extern U8 WaitForINT(PTR_SIZE IDEBaseAddress);
extern PCAM_PACKET GetATA_PacketFromSEQ_INFO(U8 bChannelNumber,U8 SeqID,U8 TAG);
extern PCAM_PACKET ReturnATA_PacketFromSEQ_INFO(U8 bChannelNumber,U8 SeqID,U8 TAG);
extern U8 NCQ_Read_Log_Ext_Page10(U8 bChannelNumber);
extern U8 ReadBuffer(U8 bChannelNumber, PU16 Buffer, U32 Count);
extern U8 WriteBuffer(U8 bChannelNumber, PU16 Buffer, U32 Count);
extern U8 IssueService(U8 bChannelNumber, U8 bID, U8 command);
extern U8 Put2ATAQueue(PCAM_ATA_PACKET CAM_ATAPacket,U8 direction);
extern void CAM_Clear_UnmaskPlugUnplugFlags(U8 bChannelNumber);
extern U8 CAM_ATA_Chnl_InMAP(U8 bChannelNumber);
extern U8 CAM_ATA_Chnl_OutMAP(U8 bChannelNumber);
extern void ATA_Timeout(U8 bChannelNumber);
/*
extern void CAM_ATA_TASK_Chnl_InMAP(PATA_TASK pATATask);
extern PATA_TASK CAM_ATA_TASK_Chnl_OutMAP(PATA_TASK pATATask);
*/
extern U8 CAM_Reset_ReinitATA(U8 bChannelNumber);
extern void cam_SetStatusByPlug_unplug(U8 bChannelNumber, U8 bID, U8 Status);


/***  cam_swap.c  ***/
extern void Check_Enclosure_PowerState(U8 bChannelNumber);


/***  cam_isr.c  ***/
extern void StartATAOperation(U8 bChannelNumber);


/***  PSS10398  ***/
extern U8 CAM_SerialBusWriteDATA(U8 Adapter_ID,PCAM_I2C_QUEUE pI2C_QUEUE);
extern void CAM_SerialBusWriteDATAPolling(U8 Adapter_ID,U32 data,U8 w_cnt);
extern U32 CAM_SerialBusReadDATAPolling(U8 Adapter_ID,U8 index,U8 r_cnt);
extern U16 ReadWinBondID_W83782D(U8 Adapter_ID,U8 bID);
extern void CAM_SBOX_HDAccess_LED(U8 bChannelNumber, U8 Active);
extern void CAMInitI2CQ(U8 Adapter_ID);
extern U8 CAM_StartI2C(U8 Adapter_ID);


/***  Serial Bus  ***/
extern U8 CAM_SerialBus(U8 Adapter_ID, PCAM_SBUS_TASK pSBTask);


	/* Error Injection */
	#ifdef _ERR_INJECT_
		extern U16 CAM_ErrorInjection(PERR_CONFIG pErrConfig);
		extern U8 CAM_ClearErrorInjection(U8 Channel, U16 ErrHandle);
		extern void ERR_CAM_NORMAL_ISR(U8 Adapter_ID,U8 SEQID);
		extern void ERR_CAM_NCQ_ISR(U8 Adapter_ID,U8 SEQID);
		extern void ERR_CAM_QUEUED_ISR(U8 Adapter_ID,U8 SEQID);
		extern U16 EI_Alloc_ErrInj_Task(void);
		extern void EI_Free_ErrInj_Task(U16 Task_Id);
		extern void EI_Insert2ChQ(U8 bCh, U16 Task_Id);
		extern U8 EI_Delete2ChQ(U8 bCh, U16 Task_Id);
		extern void CheckErrInjection(PCAM_PACKET CAM_ATAPacket, PATA_TASK pATATask);
		extern void EI_Disable_PHY(U8 Channel);
		extern void EI_Enable_PHY(U8 Channel);
	
	#endif


#endif
