/***************************************************************************
 *
 * Copyright (c) 2002 Promise Technology, Inc.  All rights reserved.
 * No part of this document may be reproduced or transmitted in any form or
 * by any means, electronic or mechanical, for any purpose, without the
 * express written permission of Promise Technology, Inc.
 *
 *
 * cam_global.h - declarations for global variables
 *
 ***************************************************************************/ 

/* 
 * 	adapter configuartion 
 */
extern ADAPTER_CONFIG	gAdapterConfig[MAX_ADAPTER_NUM];	
extern PTR_SIZE		ATABaseAddr[MAX_ATA_MODULE];
extern PTR_SIZE		ATA_ExpBaseAddr[MAX_ATA_MODULE];
extern PTR_SIZE		HostBaseAddr[MAX_ADAPTER_NUM];
/*
 *	ATA channel configuration
 */
extern CHNL_CONFIG			gChnlConfig[MAX_ATA_MODULE];
extern RESET_CH_CONTROL		gChnlResetTable[MAX_ATA_MODULE];

/*
 *	device configuration
 */
 
extern DEV_CONFIG		gDrvConfig[MAX_ATA_MODULE][MAX_ID_PER_CHNL];
extern DEV_TAG_DEVICE	gChnlDrvControlConfig[MAX_ATA_MODULE];
extern ENCLOSURE_TYPE	gBOXConfig[MAX_ATA_MODULE];
extern ENCLOSURE_STATUS gBOXStatus[MAX_ATA_MODULE];
extern ATA_TASK	boxATATask[MAX_ATA_MODULE];
extern ATA_TASK	boxLEDATATask[MAX_ATA_MODULE];
extern ATA_TASK	InternalATATask[MAX_ATA_MODULE];

/*
 *	Memory management 
 */
extern PCAM_PACKET ATAPacketQueue[MAX_ATA_MODULE][MAX_ATA_PAC];
extern U16 ATAPacketCurrent[MAX_ATA_MODULE];
extern U16 ATAPacketTail[MAX_ATA_MODULE];
extern U16 ATAPacketHead[MAX_ATA_MODULE];

/* sg queue */
extern PCAM_ATA_SG PCAM_ATA_SG_Queue[MAX_ATA_MODULE][MAX_ATA_PAC];
extern U16 CAM_ATA_SG_Current[MAX_ATA_MODULE];
extern U16 CAM_ATA_SG_Tail[MAX_ATA_MODULE];
extern U16 CAM_ATA_SG_Head[MAX_ATA_MODULE];

/* 
 * 	packets and queues 
 */
extern ATA_MODULE_PACKET_COUNT ATAPacketQueueCount[MAX_ADAPTER_NUM];
extern MODULE_TIMEOUT CAMTimeoutTimes[MAX_ADAPTER_NUM];
extern U8	ATAPacketCount[MAX_ADAPTER_NUM];

extern CAM_ATA_PACKET	ATATaskPacketQPool[MAX_ATA_MODULE][MAX_ATA_RECEIVE_PAC];
//extern PCAM_ATA_PACKET	ATATaskPacketQ[MAX_ATA_MODULE][MAX_ATA_RECEIVE_PAC];
extern U8	ATATaskPacketQ[MAX_ATA_MODULE][MAX_ATA_RECEIVE_PAC];
extern U16 ReceATAPacketCurrent[MAX_ATA_MODULE];

/* 
 *	Sequences 
 */
extern SEQ_INFO	gSEQ_INFO[MAX_ADAPTER_NUM][MAX_SEQ_ID];
extern U8 SEQIDPool[MAX_ADAPTER_NUM][MAX_SEQ_ID];
extern U8 SEQIDCurrent[MAX_ADAPTER_NUM];



/* for push queued module */

/* for ATA */
extern U8 	ATAModuleNeedPush[MAX_ATA_MODULE];
extern PCAM_ATA_PACKET ATAQueueHead[MAX_ATA_MODULE];
extern PCAM_ATA_PACKET ATAQueueTail[MAX_ATA_MODULE];
extern U8 NeedCheckFIFO[MAX_ATA_MODULE];

	/* for ATA sort */
extern PCAM_ATA_PACKET ATASortHead[MAX_ATA_MODULE][MAX_ID_PER_CHNL];
extern U32 ATASortLBAl[MAX_ATA_MODULE][MAX_ID_PER_CHNL];
extern U32 ATASortLBAh[MAX_ATA_MODULE][MAX_ID_PER_CHNL];
extern U32 ATAModuleBusy[MAX_ATA_MODULE];
extern U8 ATAModuleSEQID[MAX_ATA_MODULE];
extern PTR_SIZE ATA_Timeout_TimerID[MAX_ATA_MODULE];
extern PTR_SIZE ATA_Port_Multiplier_TimerID[MAX_ATA_MODULE];
extern PTR_SIZE BOX_Timeout_TimerID[MAX_ATA_MODULE];
extern PTR_SIZE ATA_Polling_Channel_TimerID[MAX_ATA_MODULE];
extern U8 ATAModuleReceiveTask[MAX_ATA_MODULE];

#ifdef	_MMIO_
/* for flash memory */
extern FLASH_CONFIG	gFlashConfig[MAX_ADAPTER_NUM];
extern U8 flash_model1[];
extern U8 flash_model2[];
extern U8 flash_model3[];
extern U8 flash_model4[];
extern U8 flash_model5[];
extern U8 flash_model6[];
#endif


/* PSS10398 */
extern SBOX_Type SBOXType[MAX_ADAPTER_NUM][MAX_ATA_CHNL];
extern CAM_HDAccess_LED_Buffer HDAccess_ActiveLED_Buffer[MAX_ATA_MODULE][2];
extern CAM_HDAccess_LED_Buffer HDAccess_StatusLED_Buffer[MAX_ATA_MODULE][2];
extern CAM_HDAccess_LED_Buffer HDAccess_GlobalLED_Buffer[MAX_ATA_MODULE][2];
extern U8 ChnlMapToSBOXChnl[MAX_ATA_MODULE];

extern CAM_I2C_QUEUE CAM_I2CQueue[MAX_ADAPTER_NUM][MAX_I2C_PAC+1];
extern CAM_I2C_QUEUE I2CQueueCurrent[MAX_ADAPTER_NUM];
extern U8 I2CQueueHead[MAX_ADAPTER_NUM];
extern U8 I2CQueueTail[MAX_ADAPTER_NUM];
extern U8 I2CBusy[MAX_ADAPTER_NUM];
extern U8 CAM_SBOX_HDAccess_LEDs[MAX_ADAPTER_NUM];
extern CAM_HDAccess_LED_All CAM_SBOX_HDAccessLED[MAX_ATA_MODULE];
extern U8 AdapterInitFlag[MAX_ADAPTER_NUM];
extern U8 AllHDAccessSetFlag[MAX_ADAPTER_NUM];
extern U8 DefaultStatusLed;
extern U8 PlugOff_Flag[MAX_ATA_MODULE];


/* Serial Bus */
extern SERIALBUS_ADDR SerialBusAddr[MAX_ADAPTER_NUM];
extern U8 SerialBusCurrent[MAX_ADAPTER_NUM];
extern U8 SerialBusCMD;


#ifdef Encryption
	extern U8	TCQ_Encrypt_Flag[MAX_ATA_MODULE];
#endif

/* Error Injection */
#ifdef _ERR_INJECT_
	extern U16			ErrInject_SEQ[MAX_ADAPTER_NUM];
	extern U16			ErrInject_SEQ_Timeout[MAX_ADAPTER_NUM];
	extern ERRINJ_TASK_TABLE	ErrInj_Buffer_Table[MAX_ATA_MODULE];	
	extern ERRINJ_TASK		ErrInj_Buffer[MAX_ERRINJ_TASK];
	extern U8			First_Enter_ErrInj;
	extern U8			ErrInject_UnPlug_flag[MAX_ATA_MODULE];
#endif
