/***************************************************************************
 *
 * Copyright (c) 2002 Promise Technology, Inc.  All rights reserved.
 * No part of this document may be reproduced or transmitted in any form or
 * by any means, electronic or mechanical, for any purpose, without the
 * express written permission of Promise Technology, Inc.
 *
 *
 * cam_var.c - contains declaration for global variables
 *
 ***************************************************************************/
#include "cam_con.h"
#include "cam_def.h"


/* 
 * 	adapter configuartion 
 */
ADAPTER_CONFIG	gAdapterConfig[MAX_ADAPTER_NUM];
PTR_SIZE ATABaseAddr[MAX_ATA_MODULE];
PTR_SIZE ATA_ExpBaseAddr[MAX_ATA_MODULE];
PTR_SIZE HostBaseAddr[MAX_ADAPTER_NUM];
/*
 *	ATA channel configuration
 */
CHNL_CONFIG		gChnlConfig[MAX_ATA_MODULE];
RESET_CH_CONTROL	gChnlResetTable[MAX_ATA_MODULE];

/*
 *	device configuration
 */
 
DEV_CONFIG		gDrvConfig[MAX_ATA_MODULE][MAX_ID_PER_CHNL];
DEV_TAG_DEVICE	gChnlDrvControlConfig[MAX_ATA_MODULE];
ENCLOSURE_TYPE	gBOXConfig[MAX_ATA_MODULE];
ENCLOSURE_STATUS gBOXStatus[MAX_ATA_MODULE];
ATA_TASK	boxATATask[MAX_ATA_MODULE];
ATA_TASK	boxLEDATATask[MAX_ATA_MODULE];
ATA_TASK	InternalATATask[MAX_ATA_MODULE];

/*
 *	Memory management 
 */
 
/* 
 * 	packets and queues 
 */
PCAM_PACKET ATAPacketQueue[MAX_ATA_MODULE][MAX_ATA_PAC];
U16 ATAPacketCurrent[MAX_ATA_MODULE];
U16 ATAPacketTail[MAX_ATA_MODULE];
U16 ATAPacketHead[MAX_ATA_MODULE];
ATA_MODULE_PACKET_COUNT ATAPacketQueueCount[MAX_ADAPTER_NUM];
MODULE_TIMEOUT CAMTimeoutTimes[MAX_ADAPTER_NUM];
U8	ATAPacketCount[MAX_ADAPTER_NUM];

CAM_ATA_PACKET		ATATaskPacketQPool[MAX_ATA_MODULE][MAX_ATA_RECEIVE_PAC];
//PCAM_ATA_PACKET	ATATaskPacketQ[MAX_ATA_MODULE][MAX_ATA_RECEIVE_PAC];
U8					ATATaskPacketQ[MAX_ATA_MODULE][MAX_ATA_RECEIVE_PAC];
U16 				ReceATAPacketCurrent[MAX_ATA_MODULE];

/* sg queue */
PCAM_ATA_SG PCAM_ATA_SG_Queue[MAX_ATA_MODULE][MAX_ATA_PAC];
U16 CAM_ATA_SG_Current[MAX_ATA_MODULE];
U16 CAM_ATA_SG_Tail[MAX_ATA_MODULE];
U16 CAM_ATA_SG_Head[MAX_ATA_MODULE];


/* 
 *	Sequences 
 */
SEQ_INFO	gSEQ_INFO[MAX_ADAPTER_NUM][MAX_SEQ_ID];
U8 SEQIDPool[MAX_ADAPTER_NUM][MAX_SEQ_ID];
U8 SEQIDCurrent[MAX_ADAPTER_NUM];


/* for push queued module */

/* for ATA */
U8 	ATAModuleNeedPush[MAX_ATA_MODULE];
PCAM_ATA_PACKET ATAQueueHead[MAX_ATA_MODULE];
PCAM_ATA_PACKET ATAQueueTail[MAX_ATA_MODULE];
U8 NeedCheckFIFO[MAX_ATA_MODULE];

	/* for ATA sort */
PCAM_ATA_PACKET ATASortHead[MAX_ATA_MODULE][MAX_ID_PER_CHNL];
U32 ATASortLBAl[MAX_ATA_MODULE][MAX_ID_PER_CHNL];
U32 ATASortLBAh[MAX_ATA_MODULE][MAX_ID_PER_CHNL];

U32 ATAModuleBusy[MAX_ATA_MODULE];
U8 ATAModuleSEQID[MAX_ATA_MODULE];
PTR_SIZE ATA_Timeout_TimerID[MAX_ATA_MODULE];
PTR_SIZE ATA_Port_Multiplier_TimerID[MAX_ATA_MODULE];
PTR_SIZE BOX_Timeout_TimerID[MAX_ATA_MODULE];
PTR_SIZE ATA_Polling_Channel_TimerID[MAX_ATA_MODULE];
U8 ATAModuleReceiveTask[MAX_ATA_MODULE]={FALSE};

#ifdef	_MMIO_
/* for flash memory */
FLASH_CONFIG	gFlashConfig[MAX_ADAPTER_NUM];
U8 flash_model1[] = "PMC Pm29F002";
U8 flash_model2[] = "MXIC MX29F002";
U8 flash_model3[] = "AMIC A290021";
U8 flash_model4[] = "Winbond W29C020";
U8 flash_model5[] = "ATMEL AT49F002NT";
U8 flash_model6[] = "EFST F49B002UA";
#endif

/* PSS10398 */
SBOX_Type SBOXType[MAX_ADAPTER_NUM][MAX_ATA_CHNL];
CAM_HDAccess_LED_Buffer HDAccess_ActiveLED_Buffer[MAX_ATA_MODULE][2];
CAM_HDAccess_LED_Buffer HDAccess_StatusLED_Buffer[MAX_ATA_MODULE][2];
CAM_HDAccess_LED_Buffer HDAccess_GlobalLED_Buffer[MAX_ATA_MODULE][2];

U8 ChnlMapToSBOXChnl[MAX_ATA_MODULE];

CAM_I2C_QUEUE CAM_I2CQueue[MAX_ADAPTER_NUM][MAX_I2C_PAC+1];
CAM_I2C_QUEUE I2CQueueCurrent[MAX_ADAPTER_NUM];
U8 I2CQueueHead[MAX_ADAPTER_NUM];
U8 I2CQueueTail[MAX_ADAPTER_NUM];
U8 I2CBusy[MAX_ADAPTER_NUM];
U8 CAM_SBOX_HDAccess_LEDs[MAX_ADAPTER_NUM];
CAM_HDAccess_LED_All CAM_SBOX_HDAccessLED[MAX_ATA_MODULE];
U8 AdapterInitFlag[MAX_ADAPTER_NUM];
U8 AllHDAccessSetFlag[MAX_ADAPTER_NUM];
U8 DefaultStatusLed;
U8 PlugOff_Flag[MAX_ATA_MODULE];


/* Serial Bus */
SERIALBUS_ADDR SerialBusAddr[MAX_ADAPTER_NUM];
U8 SerialBusCurrent[MAX_ADAPTER_NUM];
U8 SerialBusCMD;


#ifdef Encryption
	U8	TCQ_Encrypt_Flag[MAX_ATA_MODULE];
#endif

/* Error Injection */
#ifdef _ERR_INJECT_
	U16			ErrInject_SEQ[MAX_ADAPTER_NUM] = {0};
	U16			ErrInject_SEQ_Timeout[MAX_ADAPTER_NUM] = {0};
	ERRINJ_TASK_TABLE	ErrInj_Buffer_Table[MAX_ATA_MODULE];	
	ERRINJ_TASK		ErrInj_Buffer[MAX_ERRINJ_TASK];
	U8			First_Enter_ErrInj = TRUE;
	U8			ErrInject_UnPlug_flag[MAX_ATA_MODULE] = {FALSE};
#endif

